﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Data;
using System.Linq;
using System.Web;

namespace igWhdgTest
{
    [Serializable]
    public class Parent
    {
        public int ID { set; get; }
        public string pField1 { set; get; }
        public string pField2 { set; get; }
        public string pField3 { set; get; }


    }

    [Serializable]
    public class Child
    {
        public int ID { set; get; }
        public int rowNum { set; get; }
        public string cField1 { set; get; }
        public string cField2 { set; get; }
        public string cField3 { set; get; }
    }

    [Serializable]
    public class Parents 
    {
        IList<Parent> _parents = new List<Parent>();

        public Parents()
        {
            LoadDataParents();
        }

        public IList<Parent> LoadParents()
        {
            return _parents;
        }

        public void DeleteParent(int ID)
        {
            Parent parent = (from p in this._parents.AsQueryable<Parent>()
                where p.ID == ID
                select p).SingleOrDefault();
            _parents.Remove(parent);

        }

        private void LoadDataParents()
        {
            for (int i = 1; i < 11; i++)
            {
                _parents.Add(new Parent() { ID = i, pField1 = "Record " + i.ToString(), pField2 = "Description " + i.ToString(), pField3 = "Field 3 " + i.ToString() });
            }
        }

        public void AddParent(string pField1, string pField2, string pField3)
        {
            int id = (from p in this._parents.AsQueryable<Parent>()
                             select p.ID).Max()+1;
            _parents.Add(new Parent() { ID = id, pField1 = pField1, pField2 = pField2, pField3 = pField3 });
        }
    }

    [Serializable]
    public class Children
    {
        IList<Child> _children = new List<Child>();

        public Children()
        {
            LoadDataChildren();
        }

        private void LoadDataChildren()
        {
            for (int i = 1; i < 11; i++)
            {
                for (int j = 1; j < 4; j++)
                {
                    _children.Add(new Child() { ID = i, rowNum = j, cField1 = "Child record " + j.ToString(), cField2 = "Description row " + j.ToString(), cField3 = "C field 3" + j.ToString() });
                }
            }
        }

        public IList<Child> LoadChildren()
        {
            return _children;
        }

        public void DeleteChild(int ID, int rowNum)
        {
            Child child = (from p in this._children.AsQueryable<Child>()
                             where p.ID == ID && p.rowNum==rowNum
                             select p).SingleOrDefault();
            _children.Remove(child);

        }

        public void AddRowChild(int ID, string cField1, string cField2, string cField3)
        {

            int row1 = (from p in this._children.AsQueryable<Child>()
                       where p.ID == ID
                       select p.rowNum).ToList().Count;

            if (row1 == 0)
            {
                _children.Add(new Child() { ID = ID, rowNum = 1, cField1 = cField1, cField2 = cField2, cField3 = cField3 });
            }
            else
            {
             int row  = (from p in this._children.AsQueryable<Child>()
                           where p.ID == ID
                           select p.rowNum).Max() + 1;

             _children.Add(new Child() { ID = ID, rowNum = row, cField1 = cField1, cField2 = cField2, cField3 = cField3 });
            }
                  
        }
    }
}