﻿using System;
using System.Web;

public class WebStateRepository<T>
{
    public const string DEFAULT_SESSION_KEY = "DAF71542-BF5E-44C2-8B20-B3F5941E8E39";
    private string _sessionKey = DEFAULT_SESSION_KEY;
    private HttpContext _context = HttpContext.Current;

    private T _instance;

    public T Instance
    {
        get
        {
            if (this._instance == null)
            {
                if (this._context.Session[_sessionKey] == null)
                {
                    this._instance = Activator.CreateInstance<T>();
                    this.Persist();
                }
                else
                {
                    this._instance = (T)this._context.Session[_sessionKey];
                }
            }
            return this._instance;
        }
        set { this._instance = value; }
    }

    public void Persist()
    {
        this._context.Session[_sessionKey] = this._instance;
    }

    public WebStateRepository() { }

    public WebStateRepository(string sessionKey)
    {
        this._sessionKey = sessionKey;
    }
}